﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.DataGrid;
using C1.Silverlight;

namespace TreeDataGrid
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            dataGrid.ItemsSource = new List<Item>
            {
                new Item(),
                new Item(),
            };
            dataGrid.Columns.Add(new TreeColumn());
            dataGrid.CanUserAddRows = false;
        }
    }
    public class Item
    {

    }

    public class TreeColumn : DataGridColumn
    {
        public TreeColumn()
        {
            IsReadOnly = true;
        }
        public override object GetCellContentRecyclingKey(DataGridRow row)
        {
            return typeof(TreeCell);
        }
        public override FrameworkElement CreateCellContent(DataGridRow row)
        {
            return new TreeCell();
        }
        public override void BindCellContent(FrameworkElement cellContent, DataGridRow row)
        {
            var treeCell = (TreeCell)cellContent;
            var item = (Item)row.DataItem;
            treeCell.treeSelection.Items.Clear();
            treeCell.treeSelection.Items.Add(new C1TreeViewItem
            {
                Header = "South America",
                Items =
                {
                    new C1TreeViewItem { Header = "Brazil" },
                    new C1TreeViewItem { Header = "Argentina" },
                    new C1TreeViewItem { Header = "Uruguay" },
                }
            });
        }
        public override void UnbindCellContent(FrameworkElement cellContent, DataGridRow row)
        {
            var treeCell = (TreeCell)cellContent;
            treeCell.treeSelection.Items.Clear();
        }

        public override bool BeginEdit(FrameworkElement editingElement, RoutedEventArgs routedEventArgs)
        {
            throw new NotImplementedException();
        }
        public override void EndEdit(FrameworkElement editingElement)
        {
            throw new NotImplementedException();
        }
        public override void CancelCellEdit(FrameworkElement editingElement, object uneditedValue)
        {
            throw new NotImplementedException();
        }
        public override FrameworkElement GetCellEditingContent(DataGridRow row)
        {
            throw new NotImplementedException();
        }
        public override object PrepareCellForEdit(FrameworkElement editingElement)
        {
            throw new NotImplementedException();
        }
    }
}
